const fs = require('fs');
const path = require('path');

const configFile = path.resolve(__dirname, './../../../config.json');
const requiredConfigParams = [
    'userEmail',
    'tokenType',
    'oauthToken',
    'datasourceAggregatorUrl'
];

let store = {};

const removeConfig = (extension) => {
    
    const config = getConfig();

    config.filter(function(value){
        return value !== extension;       
    });
    
    setConfig(config);
}

const setConfig = (config) => {

    const configObject = Object.assign({}, config);
    validateConfig(configObject);
    store = Object.assign({}, configObject);
}

const getConfig = () => store;

const validateConfig = (config) => {
    requiredConfigParams.forEach((param) => {
        if (!config.hasOwnProperty(param))
            throw new Error(`Missing config parameter: ${param}`);
    });
}

module.exports = {
    setConfig,
    getConfig,
    removeConfig
  };
